/* Programm-Name:    NDXDUMP.PRG
 * Autor:            Isaac Said-Nejad
 * Aufruf:           NDXDUMP <Dateiname> 
 * Copyright (c):    Nantucket Corp.
 * Compilieren mit:  /n/w/p             */


#include "NdxDump.CH"

FUNCTION NdxDump(ndx_file)
    LOCAL handle, stack_pointer, buffer, read, root, key_size
    LOCAL key_type, size_key_item, item_number, down, items
    LOCAL item_at, child_page, recno
    LOCAL stack[STACK_SIZE]

    CLEAR SCREEN

    IF PCOUNT() == 0
        ? "Syntax: NDXDUMP <Dateiname>"
        QUIT
    ENDIF

    handle := FOPEN(ndx_file, 0)

    IF FERROR() != 0
        ? "Fehler beim ffnen der Datei ", FERROR()
        QUIT
    ENDIF

    stack_pointer := 1
    buffer := SPACE(PAGE_SIZE)
    read := FREAD(handle, @buffer, PAGE_SIZE)

    IF read <> PAGE_SIZE
        ? "Fehler beim Lesen des Headers"
        QUIT
    ENDIF

    root := BIN2L(SUBSTR(buffer, 1, LONG))
    key_size := BIN2W(SUBSTR(buffer, 13, UNSIGNED))
    KEY_TYPE := BIN2W(SUBSTR(buffer, 17, UNSIGNED))
    SIZE_KEY_ITEM := BIN2L(SUBSTR(buffer, 19, LONG))

    ? "Root: ", root
    ? "Anzahl Pages: ", BIN2L(SUBSTR(buffer, 5, LONG))
    ? "Schlssel-Lnge: ", key_size
    ? "Max. Anzahl Schlssel pro Page: ", BIN2W(SUBSTR(buffer, 15, UNSIGNED))
    ? "Schlssel-Typ: ", KEY_TYPE
    ? "Eintrag-Lnge: ", SIZE_KEY_ITEM
    ? "Unique: ", IF(SUBSTR(buffer, 24, 1) == CHR(1), "Ein", "Aus")
    ? "Schlssel-Ausdruck: ", SUBSTR(buffer, 25)
    ?

    item_number := 1
    down := .T.
    SET ALTERNATE TO NDXDUMP
    SET ALTERNATE ON
    DO WHILE .T.
        IF root <> 0 .AND. down
            FSEEK(handle, root * PAGE_SIZE)

            read := FREAD(handle, @buffer, PAGE_SIZE)

            IF read <> PAGE_SIZE
                ? "Fehler beim Lesen der Page"
                QUIT
            ENDIF

            items := BIN2L(SUBSTR(buffer, 1, LONG))
            item_number := 1
            item_at := LONG + 1
            child_page := BIN2L(SUBSTR(buffer,item_at, LONG))
            stack_pointer := stack_pointer + 4
            IF stack_pointer > STACK_SIZE
                ? "Programm-Stack-Overflow"
                QUIT
            ENDIF

            stack[stack_pointer-4] := root
            stack[stack_pointer-3] := items
            stack[stack_pointer-2] := item_number                          
            stack[stack_pointer-1] := item_at
            root := child_page

        ELSEIF item_number <= items
            recno := BIN2L(SUBSTR(buffer, item_at+LONG, LONG))

            IF recno <> 0 .AND. item_number <= items
                ?? recno
                IF KEY_TYPE = 0
                    ?? SUBSTR(buffer, item_at+LONG2, key_size)
                ELSE
                    ?? ctof(SUBSTR(buffer, item_at+LONG2,key_size))
                ENDIF
                ?
            ENDIF

            item_number := item_number + 1
            item_at := LONG + ((item_number-1)*SIZE_KEY_ITEM)+1
            child_page := BIN2L(SUBSTR(buffer, item_at, LONG))
            stack[stack_pointer-2] := item_number
            stack[stack_pointer-1] := item_at
            root := child_page
            down := .T.

        ELSE
            stack_pointer := stack_pointer -4

            IF stack_pointer < 5
                EXIT
            ENDIF

            root := stack[stack_pointer-4]
            items := stack[stack_pointer-3]
            item_number := stack[stack_pointer-2]
            item_at := stack[stack_pointer-1]
            down := .F.
            FSEEK(handle, root*PAGE_SIZE)
            read := FREAD(handle, @buffer, PAGE_SIZE)
            IF read <> PAGE_SIZE
                ? "Fehler beim Lesen der Page"
                QUIT
            ENDIF

        ENDIF
    ENDDO

RETURN NIL




