/* Programm-Name:    NTXDUMP.PRG
 * Autor:            Isaac Said-Nejad
 * Aufruf:           NTXDUMP <Dateiname> 
 * Copyright (c):    Nantucket Corp.
 * Compilieren mit:  /n/w/p             */


#include "NtxDump.CH"

FUNCTION NtxDump(ntx_file)
    LOCAL handle, stack_pointer, read, root, key_size
    LOCAL item_number, down, buffer, items, item_pointer
    LOCAL child_page, item_at
    LOCAL stack[STACK_SIZE]

    CLEAR SCREEN

    IF PCOUNT() == 0
        ? "Syntax: NTXDUMP <Dateiname>"
        QUIT
    ENDIF

    handle := FOPEN(ntx_file, 0)

    IF FERROR() != 0
        ? "Fehler beim ffnen der Datei ", FERROR()
        QUIT
    ENDIF

    stack_pointer := 1
    buffer := SPACE(PAGE_SIZE)
    read := FREAD(handle, @buffer, PAGE_SIZE)

    IF read <> PAGE_SIZE
        ? "Fehler beim Lesen des Headers"
        QUIT
    ENDIF

    ? "Datei-ID: ", BIN2W(SUBSTR(buffer, 1, UNSIGNED))
    ? "Index-Version: ", BIN2W(SUBSTR(buffer, 3, UNSIGNED))
    root := BIN2L(SUBSTR(buffer, 5, LONG))
    ? "Root d. aktiven Pages: ", root
    ? "Root d. unbenutzten Pages: ", BIN2L(SUBSTR(buffer, 9, LONG))
    ? "Eintrag-Gre: ", BIN2W(SUBSTR(buffer, 13, UNSIGNED))
    key_size := BIN2W(SUBSTR(buffer, 15, UNSIGNED))
    ? "Schlssel-Gre: ", BIN2W(SUBSTR(buffer, 15, UNSIGNED))
    ? "Dezimal-Stellen: ", BIN2W(SUBSTR(buffer, 17, UNSIGNED))
    ? "Max. Eintrge pro Page: ", BIN2W(SUBSTR(buffer, 19, UNSIGNED))
    ? "Min. Eintrge pro Page: ", BIN2W(SUBSTR(buffer, 21, UNSIGNED))
    ? "Schlssel-Ausdruck: ", SUBSTR(buffer, 23, 256)
    ? "Unique: ", IF(BIN2I(SUBSTR(buffer, 279,SIGNED))>0, "Ein", "Aus")
    ?

    item_number := 1
    down := .T.
    SET ALTERNATE TO NTXDUMP
    SET ALTERNATE ON
    DO WHILE .T.
        IF root <> 0 .AND. down
            FSEEK(handle, root)

            read := FREAD(handle, @buffer, PAGE_SIZE)

            IF read <> PAGE_SIZE
                ? "Fehler beim Lesen der Page"
                QUIT
            ENDIF

            items := BIN2W(SUBSTR(buffer, 1, 2))
            item_number := 1
            item_pointer := UNSIGNED + 1
            item_at := BIN2W(SUBSTR(buffer, item_pointer, 4))
            child_page := BIN2L(SUBSTR(buffer,item_at+1, 4))
            stack_pointer := stack_pointer + 4
            IF stack_pointer > STACK_SIZE
                ? "Programm-Stack-Overflow"
                QUIT
            ENDIF

            stack[stack_pointer-4] := root
            stack[stack_pointer-3] := items
            stack[stack_pointer-2] := item_number                          
            stack[stack_pointer-1] := item_at
            root := child_page

        ELSEIF item_number <= items
            ? BIN2L(SUBSTR(buffer, item_at+1+LONG,    LONG)),;
                    SUBSTR(buffer, item_at+  LONG2+5, key_size)
            item_number := item_number + 1
            stack[stack_pointer-2] := item_number
            item_pointer := (item_number-1) * 2 + UNSIGNED + 1
            item_at := BIN2W(SUBSTR(buffer, item_pointer, 4))
            child_page := BIN2L(SUBSTR(buffer, item_at+1, 4))
            stack[stack_pointer-1] := item_at
            stack[stack_pointer-3] := items
            root := child_page
            down := .T.

        ELSE
            stack_pointer := stack_pointer -4

            IF stack_pointer < 5
                EXIT
            ENDIF

            root := stack[stack_pointer-4]
            items := stack[stack_pointer-3]
            item_number := stack[stack_pointer-2]
            item_at := stack[stack_pointer-1]
            down := .F.
            FSEEK(handle, root)
            read := FREAD(handle, @buffer, PAGE_SIZE)
            IF read <> PAGE_SIZE
                ? "Fehler beim Lesen der Page"
                QUIT
            ENDIF

        ENDIF
    ENDDO

RETURN NIL




